/* -*-C-*-
 *
 * $Revision: 1.2 $
 *   $Author: mquinn $
 *     $Date: 1999/01/26 14:07:12 $
 *
 * Copyright (c) 1996 Advanced RISC Machines Limited.
 * All Rights Reserved.
 *
 *   Project: ANGEL
 *
 *     Title: The message to send up when we boot
 */

#ifndef angel_banner_h
#define angel_banner_h

#include "toolver.h"
#include "devconf.h"

#if ENABLE_MMU
# define MMU_STRING "MMU on, "
#else
# define MMU_STRING "MMU off, "
#endif

#if ENABLE_CLOCK_SWITCHING
# define CSW_STRING "Clock/Sw on "
#else
# define CSW_STRING "Clock/Sw off "
#endif

#if CACHE_SUPPORTED
#define CACHE_STRING "Caches on, "
#else
#define CACHE_STRING "Caches off, "
#endif

#if HANDLE_INTERRUPTS_ON_IRQ
#define INTERRUPTS_STRING "(IRQ), "
#else
#define INTERRUPTS_STRING "(FIQ), "
#endif
#if ETHERNET_SUPPORTED
#define MEDIA_STRING "(serial or ethernet)"
#else
#define MEDIA_STRING "(serial)"
#endif

#define ANGEL_BANNER \
"Angel Debug Monitor for EBSA285 " INTERRUPTS_STRING \
CACHE_STRING \
MMU_STRING CSW_STRING MEDIA_STRING "\n" \
TOOLVER_ANGEL " on " __DATE__ " at " __TIME__ "\n"

#endif

 /* EOF banner_h */
