#ifndef __BOOTP_H_LOADED
#define __BOOTP_H_LOADED
/****************************************************************************
**                                                                          *
**  Copyright  1997						     								*
**  by Digital Equipment Corporation, Maynard, Massachusetts.		     	*
**                                                                          *
**  All Rights Reserved							     						*
**                                                                          *
**  Permission  is  hereby  granted  to  use, copy, modify and distribute   *
**  this  software  and  its  documentation,  in  both  source  code  and   *
**  object  code  form,  and without fee, for the purpose of distribution   *
**  of this software  or  modifications  of this software within products   *
**  incorporating  an  integrated   circuit  implementing  Digital's  		*
**  StrongARM architecture,  regardless  of the  source of such integrated 	*
**	circuit, provided that the  above copyright  notice and this permission *
**  notice appear  in  all copies,  and  that  the  name  of  Digital  		*
**  Equipment Corporation  not  be  used  in advertising or publicity 		*
**  pertaining to distribution of the  document  or  software without 		*
**  specific, written prior permission.							            *
**                                                                          *
**  Digital  Equipment  Corporation   disclaims  all   warranties  and/or   *
**  guarantees  with  regard  to  this  software,  including  all implied   *
**  warranties of fitness for  a  particular purpose and merchantability,   *
**  and makes  no  representations  regarding  the use of, or the results   *
**  of the use of, the software and documentation in terms of correctness,  *
**  accuracy,  reliability,  currentness  or  otherwise;  and you rely on   *
**  the software, documentation and results solely at your own risk.	    *
**                                                                          *
**  StrongARM is a trademark of Digital Equipment Corporation               *
**                                                                          *
*****************************************************************************/

#include "address.h"


/* bootp_boot - performs a bootp transaction
 *
 * Arguments:
 *     device_no       - device on which request should be sent
 *     input_file_name - file name supplied by caller; or null for default. Null terminated;
 *     server_addr     - returned server IP address
 *     boot_file_name  - returned boot file name supplied by server
 *     
 * Returned value:
 *     0   - bootp successful; server_addr and boot_file_name valid;
 *     -ve  - bootp failed; server_addr and boot_file_name invalid.
 */
extern int bootp_boot(int device_no); 

/* bootp_init_module - initialise the module 
 */
extern void bootp_init_module(void);

#endif /* __BOOTP_H_LOADED */

