/*
  errors.h

	List of defines for errors - all negative
	
*/


#define ERR_BASE 					0x80000000
// AM79C961.C
#define ERR_RXRINGEMPTY					(ERR_BASE+1)
#define ERR_CHKRECV						(ERR_BASE+2)
#define ERR_ETHERBUFTOOLONG				(ERR_BASE+3)
#define ERR_TXRINGFULL					(ERR_BASE+4)
#define ERR_ETHERPACKETTOOLONG			(ERR_BASE+5)
#define ERR_CHKSEND						(ERR_BASE+6)
#define ERR_MACCHECKSUM					(ERR_BASE+7)
#define ERR_OUTOFDEVICESPACE			(ERR_BASE+8)
#define ERR_INVALIDDEVICENUM			(ERR_BASE+9)
#define ERR_CHKSENDERR				(ERR_BASE+10)
#define ERR_CHKRECVERR				(ERR_BASE+11)

// EDEVICE.C
#define ERR_INITUNKNOWNDEVICE			(ERR_BASE+12)
#define ERR_READUNKNOWNDEVICE			(ERR_BASE+13)
#define ERR_WRITEUNKNOWNDEVICE			(ERR_BASE+14)
#define ERR_FLUSHUNKNOWNDEVICE			(ERR_BASE+15)
#define ERR_HWUNKNOWNDEVICE				(ERR_BASE+16)

// ETHERNET.C							
#define ERR_EOUTOFPROTOCOLSPACE			(ERR_BASE+18)
#define ERR_EBUFFERTOOSMALL				(ERR_BASE+19)
#define ERR_ENOWTRECVD					(ERR_BASE+20)
										
// IP.C									
#define ERR_IPOUTOFPROTOCOLSPACE		(ERR_BASE+22)
#define ERR_IPBUFFERTOOSMALL			(ERR_BASE+23)
#define ERR_IPARPNOTRESOLVED			(ERR_BASE+24)
// ARP.C								
#define ERR_ARPLOOKUPFAIL				(ERR_BASE+25)
#define ERR_ARPUNKNOWNDEVICE			(ERR_BASE+26)
#define ERR_ARPRESOLVEFAIL				(ERR_BASE+27)
										
// UDP.C								
#define ERR_UDPPORTEXISTS				(ERR_BASE+29)
#define ERR_UDPNOFREESLOTS				(ERR_BASE+30)
#define ERR_UDPBUFFERTOOSMALL			(ERR_BASE+31)
										
// SOCKET.C								
#define ERR_SOCKNOPROTO					(ERR_BASE+33)
#define ERR_SOCKPROTONOTFOUND			(ERR_BASE+34)
#define ERR_SOCKDOMAINNOTFOUND			(ERR_BASE+35)
#define ERR_SOCKNONAME					(ERR_BASE+36)
#define ERR_SOCKNODATA					(ERR_BASE+37)
#define ERR_SOCKBUFFERTOOSHORT			(ERR_BASE+38)
#define ERR_SOCKSOCKNOTFOUND			(ERR_BASE+39)
#define ERR_SOCKPACKETTOOLONG			(ERR_BASE+40)
#define ERR_SOCKOUTOFFRAMES				(ERR_BASE+41)
#define ERR_SOCKOUTOFISTSPACE			(ERR_BASE+42)
#define ERR_SOCKCLOSE					(ERR_BASE+43)
							   

#define ERR_RARPNOTRESOLVED				(ERR_BASE+44)	 
#define ERR_MEM2PCIFAIL					(ERR_BASE+45)
