//
// Copyright (C) 1997 by
// Digital Equipment Corporation, Maynard, Massachusetts.
// All rights reserved.
//
// This software is furnished under a license and may be used and copied
// only  in  accordance  of  the  terms  of  such  license  and with the
// inclusion of the above copyright notice. This software or  any  other
// copies thereof may not be provided or otherwise made available to any
// other person.  No title to and  ownership of the  software is  hereby
// transferred.
//
// The information in this software is  subject to change without notice
// and  should  not  be  construed  as a commitment by Digital Equipment
// Corporation.
//
// Digital assumes no responsibility for the use  or  reliability of its
// software on equipment which is not supplied by Digital.
//
//
// Abstract:    
//
// Author:      
//
// Revision:    
//
// Modifications:
//
//     $History: $
//

/*
 *  Local definitions.
 */
#define FLASH_BYTE                      0x000000
#ifdef ANGEL
#define U32 unsigned int
#endif

#define NUMBER_OF_BLOCKS                16

#ifndef TRUE 
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0 
#endif

#ifndef ANGEL
//
// structure for routines that actually sniff the buses
//
typedef struct {
  U8 bus;                               // bus to use
  U8 slot;                              // slot (idsel)
  U8 function;                          // function (not completely supported)
  U16 sizeIo[4];                        // io space size required by device
  U32 sizeMem[4];                       // mem space size required by device
} devInfo;

//
// values returned by system bios
//
typedef struct {
  U8 hwMech;                            // hardware mechanism
  U8 major;                             // interface major revision
  U8 minor;                             // hardware minor revision
  U8 numBus;                            // number of last PCI bus in system
} biosInfo;

typedef struct {
  unsigned short bus;
  unsigned short slot;
  unsigned short function;
  unsigned short misc;
  unsigned int bar0Phys;
  unsigned int bar0Virt;
  unsigned int romPhys;
  unsigned int romVirt;
} deviceInfo;

#endif

