;/*****************************************************************************

;       Copyright  1995, 1996 Digital Equipment Corporation,
;                       Maynard, Massachusetts.

;                        All Rights Reserved

;Permission to use, copy, modify, and distribute this software and its 
;documentation for any purpose and without fee is hereby granted, provided  
;that the copyright notice and this permission notice appear in all copies  
;of software and supporting documentation, and that the name of Digital not  
;be used in advertising or publicity pertaining to distribution of the software 
;without specific, written prior permission. Digital grants this permission 
;provided that you prominently mark, as not part of the original, any 
;modifications made to this software or documentation.

;Digital Equipment Corporation disclaims all warranties and/or guarantees  
;with regard to this software, including all implied warranties of fitness for 
;a particular purpose and merchantability, and makes no representations 
;regarding the use of, or the results of the use of, the software and 
;documentation in terms of correctness, accuracy, reliability, currentness or
;otherwise; and you rely on the software, documentation and results solely at 
;your own risk. 

;******************************************************************************

;  SA-110 MMU specifics	- constants, registers etc.

;	$Id: mmu_h.s,v 1.1 1997/03/24 11:43:50 rusling Exp $

;******************************************************************************/


DCACHE_SIZE		EQU	0x4000  ; 16kB Dcache
DCACHE_LINE		EQU	0x20	; 32B cache line entry

L2_CONTROL		EQU	0x1	; domain0, page table pointer

L1_TABLE_ENTRIES	EQU	0x1000	; 16kB table (word entries) 
L2_TABLE_ENTRIES	EQU	0x100	;  1kB table (word entries) 


DRAM_ACCESS		EQU	0xC0E	; AP=11, domain0, C=1, B=1
SSRAM_ACCESS		EQU	0x0FFD	; AP=11, domain0, C=1, B=1
FLASH_ACCESS		EQU	0x80A	; AP=10, domain0, C=1, B=0
EPROM_ACCESS		EQU	0x0AA9	; AP=10, domain0, C=1, B=0
IO_ACCESS		EQU	0xC02	; AP=11, domain0, C=0, B=0


; Definitions used in conditional assembly of Icache, Dcache and Write Buffer
; options

IC_ON		EQU	0x1000
IC_OFF		EQU	0x0

DC_ON		EQU	0x4
DC_OFF		EQU	0x0

WB_ON		EQU	0x8
WB_OFF		EQU	0x0


; Bit definitions for the control register: 

; enables are logically OR'd with the control register
; use bit clears (BIC's) to disable functions 
;	*** all bits cleared on RESET ***

EnableMMU		EQU	0x1
EnableAlignFault	EQU	0x2
EnableDcache		EQU	0x4
EnableWB		EQU	0x8
EnableBigEndian		EQU	0x80
EnableMMU_S		EQU	0x100		; selects MMU access checks 
EnableMMU_R		EQU	0x200		; selects MMU access checks 
EnableIcache		EQU	0x1000

	END
