/*****************************************************************************

       Copyright  1997 Digital Equipment Corporation,
                       Maynard, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, provided  
that the copyright notice and this permission notice appear in all copies  
of software and supporting documentation, and that the name of Digital not  
be used in advertising or publicity pertaining to distribution of the software 
without specific, written prior permission. Digital grants this permission 
provided that you prominently mark, as not part of the original, any 
modifications made to this software or documentation.

Digital Equipment Corporation disclaims all warranties and/or guarantees  
with regard to this software, including all implied warranties of fitness for 
a particular purpose and merchantability, and makes no representations 
regarding the use of, or the results of the use of, the software and 
documentation in terms of correctness, accuracy, reliability, currentness or
otherwise; and you rely on the software, documentation and results solely at 
your own risk. 

******************************************************************************

******************************************************************************/

#include "platform.h"
#include "post.h"

#define MAX_MHZ 12
static char *MHzString[MAX_MHZ] =
{
  "88.3", "95.6", "99.4", "106.7", "143.5", "150.9",
  "161.9", "169.3", "191.3", "202.4", "213.4", "228.1",
} ;

static int MHzThresholds[MAX_MHZ - 1] =
{
  252065, 237501, 224984, 189136, 157388, 148222, 
  139881, 128842, 117652, 111434, 104976,
} ;

char *MHz(int value)
{
  int i ;

  i = 0;
  while (i < (MAX_MHZ - 1)) {
    if (MHzThresholds[i] < value) break ;
    i++ ;
  }
  return MHzString[i] ;
}

int calibrate(struct testResults *pResults)
{
  register int value = (int)pResults ;
  int i ; 
  unsigned int t1, t2 ;

  PutString("Calculating CPU Core Frequency\n\r") ;
/*
 * Setup timer 3 with a LARGE value
 */
  PUT32(CSR_BASE + TIMER_3_LOAD, 0xffffffff);
  PUT32(CSR_BASE + TIMER_3_CONTROL,0xCC);          /* periodic, external pin */

  t1 =   GET32(CSR_BASE + TIMER_3_VALUE) ;

  for (i = 0 ; i < (16 * 16 * 16 * 16 * 16) ; i++) 
    value = (value ^ (~i)) ;

  t2 =   GET32(CSR_BASE + TIMER_3_VALUE) ;

  pResults ->cpuFrequency = value ;
  return (t1-t2) ;
}
