//
// Copyright (C) 1996 by
// Digital Equipment Corporation, Maynard, Massachusetts.
// All rights reserved.
//
// This software is furnished under a license and may be used and copied
// only  in  accordance  of  the  terms  of  such  license  and with the
// inclusion of the above copyright notice. This software or  any  other
// copies thereof may not be provided or otherwise made available to any
// other person.  No title to and  ownership of the  software is  hereby
// transferred.
//
// The information in this software is  subject to change without notice
// and  should  not  be  construed  as a commitment by Digital Equipment
// Corporation.
//
// Digital assumes no responsibility for the use  or  reliability of its
// software on equipment which is not supplied by Digital.
//
//
// Abstract:    
//
// Author:      
//
// Revision:    $Header: /remote_disks/reo_jimlad_rz0c/users/rusling/release/eb285/27May1146/eb285/post/RCS/timers.c,v 1.1 1997/05/27 10:27:41 rusling Exp $
//
// Modifications:
//
//     $History: $
//
#include "platform.h"
#include "post.h"

static unsigned int initValues[] = {
  0xFFFFFF, 0x20000, 0x8000, 0x800000,
} ;

int timerTests(struct testResults *pResults)
{
  int i ;
  unsigned int value ;
  int result = 0 ;

  PutString("Timer Tests [v1.0]\n\r") ;
  
/*
 * Setup timers. 
 */
  PUT32(CSR_BASE + TIMER_1_LOAD, initValues[0]);
  PUT32(CSR_BASE + TIMER_2_LOAD, initValues[1]);
  PUT32(CSR_BASE + TIMER_3_LOAD, initValues[2]);
  PUT32(CSR_BASE + TIMER_4_LOAD, initValues[3]);
  PUT32(CSR_BASE + TIMER_1_CONTROL,0x80);          /* free running */
  PUT32(CSR_BASE + TIMER_2_CONTROL,0xC0);          /* periodic */
  PUT32(CSR_BASE + TIMER_3_CONTROL,0xCC);          /* periodic, external pin */
  PUT32(CSR_BASE + TIMER_4_CONTROL,0xC0);          /* periodic */

/*
 * wait a while
 */
  for (i = 0 ; i < 100 ; i++) {
    PutString(".") ;
  }
  PutString("\n\r") ;

  value = GET32(CSR_BASE + TIMER_1_VALUE) ;
  if (value == initValues[0]) {
    PutString("ERROR: Timer 1 not running\n\r") ; result = -1 ;
  }

  value = GET32(CSR_BASE + TIMER_2_VALUE) ;
  if (value == initValues[1]) {
    PutString("ERROR: Timer 2 not running\n\r") ; result = -1 ;
  }

  value = GET32(CSR_BASE + TIMER_3_VALUE) ;
  if (value == initValues[2]) {
    PutString("ERROR: Timer 3 not running\n\r") ; result = -1 ;
  }

  value = GET32(CSR_BASE + TIMER_4_VALUE) ;
  if (value == initValues[3]) {
    PutString("ERROR: Timer 4 not running\n\r") ; result = -1 ;
  }

  PutString("Done\n\r") ;
  return result ;
}

