/* Simple program to read a binary file from stdin and write the data as
 * an ARM assembler array. eg DCB 0x01 0x02 0x03 0x04 ...
 *
 * Copyright Digital Semiconductors 1996.
 *
 */
#define __POSIX_SOURCE 1

#include <stdio.h>

/* For compatability with K&R compilers */
#ifdef unix
#  ifndef __unix
#    define __unix
#  endif
#endif

main(int argc, char *argv[])
{
  int     c;
  int     count=0;
  FILE    *in, *out ;

  if (argc < 3) {
    fprintf(stderr, "ERROR: no files specified\n") ;
    exit(1) ;
  }

  /* 
   * Open the files
   */
  in = fopen(argv[1], "rb") ;
  if (in == NULL) {
    fprintf(stderr, "ERROR: opening input file %s\n", argv[1]) ;
  }
  out = fopen(argv[2], "w") ;
  if (out == NULL) {
    fprintf(stderr, "ERROR: opening output file %s\n", argv[2]) ;
  }

  /*
   * Now process the files 
   */
  while((c = fgetc(in)) != EOF) {
    if((count++) % 8 == 0) {
      fprintf(out, "\n\t DCB ");
    } else {
      fprintf(out, ",");
    }
    fprintf(out, "0x%02x", c);
  }
  fprintf(out, "\n\t END\n");
  
  exit(0) ;
}
